#include "dx_mesh.h"


CDXMesh::CDXMesh():
	m_lpMesh(NULL)
{
}

CDXMesh::~CDXMesh()
{
	Destroy();
}

void CDXMesh::Destroy()
{
	RELEASE(m_lpMesh);
	m_MaterialArray.clear();
}



//bVt@Cǂݍ
bool CDXMesh::Load(CDXDevice &DXDevice,LPCTSTR lpszFileName)
{
	Destroy();

	DWORD dwMeshSubsets;
	//VK[h
	LPD3DXBUFFER lpMaterialBuffer = NULL;
	LPD3DXBUFFER lpAdjacencyBuffer = NULL;
	LPD3DXMESH lpMesh=NULL;
	HRESULT hr;
	{
		hr=	D3DXLoadMeshFromX(lpszFileName,
				D3DXMESH_SYSTEMMEM,
				DXDevice.Handle(),
				&lpAdjacencyBuffer,
				&lpMaterialBuffer,
				NULL,
				&dwMeshSubsets,
				&lpMesh);

		if(FAILED(hr)){
			//DXTRACE_ERR(_T(__FUNCTION__)_T("():3DbṼ[hɎs"),hr);
			return false;
		}

		LPD3DXMESH lpMeshNew=NULL;
		if(!ConvertMesh(lpMesh,lpMeshNew)){
			RELEASE(lpMesh);
			return false;
		}
		RELEASE(lpMesh);
		lpMesh=lpMeshNew;
	}

	//}eAƃeNX`̐ݒ
	D3DXMATERIAL* lpMat=(D3DXMATERIAL*)lpMaterialBuffer->GetBufferPointer();
	for(DWORD i=0;i<dwMeshSubsets;i++){
		//}eA
		MESHMATERIALINFO mat;
		mat.material=lpMat[i].MatD3D;
		if(lpMat[i].pTextureFilename){
			mat.strTextureName=lpMat[i].pTextureFilename;
		}
		m_MaterialArray.push_back(mat);
	}
	RELEASE(lpMaterialBuffer);

	m_lpMesh=lpMesh;
	return true;
}


bool CDXMesh::ConvertMesh(LPD3DXBASEMESH lpOrgMesh,LPD3DXMESH &lpMesh)
{
	//foCX擾
	LPDIRECT3DDEVICE9 lpDevice=NULL;
	if(FAILED(lpOrgMesh->GetDevice(&lpDevice))){
		//TRACE(_T("Failed to get device handler"));
		return false;
	}

	//bVVXeɊm
	lpMesh = NULL;
	if(FAILED(lpOrgMesh->CloneMeshFVF( D3DXMESH_SYSTEMMEM, MESHVERTEX_FVF, lpDevice, &lpMesh))){
		//TRACE(_T("Failed to CloneMeshFVF"));
		//foCX̎QƃJE^炷
		RELEASE(lpDevice);
		return false;
	}
	//foCX̎QƃJE^炷
	RELEASE(lpDevice);

	return true;
}



//ʏ̎擾
bool CDXMesh::GetMeshInfo(std::vector<MESHVERTEX> &rVertexArray,std::vector<DWORD> &rIndexArray,std::vector<D3DXATTRIBUTERANGE> &rAttributes)
{
	rVertexArray.clear();
	rIndexArray.clear();

	LPD3DXMESH lpMesh=m_lpMesh;
	{
		//===========================================
		// _obt@擾
		//===========================================
		LPDIRECT3DVERTEXBUFFER9 lpVB;
		lpMesh->GetVertexBuffer(&lpVB);
		// _obt@̃TCY擾
		D3DVERTEXBUFFER_DESC vbdesc;
		lpVB->GetDesc(&vbdesc);
		DWORD nVertexCount = (vbdesc.Size/sizeof(MESHVERTEX));

		// _obt@bN
		MESHVERTEX *lpV;
		if(SUCCEEDED(lpVB->Lock( 0, 0, (VOID**)&lpV, D3DLOCK_READONLY))){
			rVertexArray.assign(lpV,lpV+nVertexCount);	//Rs[
			lpVB->Unlock();
			RELEASE(lpVB);
		}else{
			RELEASE(lpVB);
			return false;
		}
	}
	{
		//CfbNXobt@Rs[
		LPDIRECT3DINDEXBUFFER9 pIB;
		lpMesh->GetIndexBuffer(&pIB);

		D3DINDEXBUFFER_DESC IDesc;
		pIB->GetDesc( &IDesc );

		WORD  *pw = NULL;
		DWORD *pd = NULL;
		if(IDesc.Format == D3DFMT_INDEX16){
			pIB->Lock( 0, 0, (void**)&pw, D3DLOCK_READONLY);
		}else if(IDesc.Format == D3DFMT_INDEX32){
			pIB->Lock( 0, 0, (void**)&pd, D3DLOCK_READONLY);
		}else{
			RELEASE(pIB);
			return false;
		}

		DWORD dwNumFaces=lpMesh->GetNumFaces();
		if( IDesc.Format == D3DFMT_INDEX16 ){
			//WORD
			rIndexArray.resize(dwNumFaces*3);
			for(DWORD idx = 0;idx < dwNumFaces; idx++ ){
				rIndexArray[idx*3+0] = *(pw++);
				rIndexArray[idx*3+1] = *(pw++);
				rIndexArray[idx*3+2] = *(pw++);
			}
		}else{//if( IDesc.Format == D3DFMT_INDEX32 ){
			//DWORD
			rIndexArray.assign(pd,pd+dwNumFaces*3);
		}
		pIB->Unlock();
		RELEASE(pIB);
	}

	DWORD dwAttributes;
	if(FAILED(lpMesh->GetAttributeTable(NULL,&dwAttributes))){
		//strErr=_T("Failed to get mesh attributes");
		return false;
	}
	rAttributes.resize(dwAttributes);
	if(FAILED(lpMesh->GetAttributeTable(&rAttributes[0],&dwAttributes))){
		//strErr=_T("Failed to get mesh attributes");
		return false;
	}
	return true;
}
