//---------------------------------------------------------------------------
//
//   ImportX
//
//          Copyright(C) 2010, Claybird
//          Licensed under New BSD License
//
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "MQPlugin.h"
#include "dx_dev.h"
#include "dx_mesh.h"

BOOL LoadX(LPCTSTR filename, MQDocument doc);
HINSTANCE g_hInstance;

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	g_hInstance=(HINSTANCE)hModule;
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xB3A8500C;
	*ID      = 0x10E3030A;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return ".X Importer Ver.0.01   Copyright(C) 2010, Claybird";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// ͗pvOCł
	return MQPLUGIN_TYPE_IMPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "DirectX Retained Mode X (*.x)";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "x";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQImportFile
//    [ǂݍ]hbOhbvœǂݍނƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQImportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return LoadX(filename, doc);
	}
	return FALSE;
}

//--------------

#define WINDOW_NAME "EmptyWindow"

#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 240

// ̃EBhEvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam){
	if(mes == WM_DESTROY) {PostQuitMessage(0); return 0;}
	return DefWindowProc(hWnd, mes, wParam, lParam);
}

//IɃbZ[W[v
bool UtilDoMessageLoop()
{
	MSG msg;
	if(PeekMessage (&msg,NULL,0,0,PM_NOREMOVE)){
		if(!GetMessage (&msg,NULL,0,0)){
			return false;
		}

		TranslateMessage(&msg);
		DispatchMessage(&msg);
		return true;
	}
	return false;
}


HWND CreateEmptyWindow(HWND hWndParent)
{
	// AvP[V̏
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, g_hInstance, NULL, NULL,
		(HBRUSH)(COLOR_WINDOW+1), NULL, WINDOW_NAME, NULL};
	//if(!RegisterClassEx(&wcex))return NULL;
	RegisterClassEx(&wcex);

	DWORD WndStyle = WS_OVERLAPPEDWINDOW & ~(WS_MAXIMIZEBOX | WS_SIZEBOX);
	RECT WndRect={0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
	AdjustWindowRect( &WndRect, WndStyle, false );

	HWND hWnd= CreateWindow(WINDOW_NAME, WINDOW_NAME, WndStyle,CW_USEDEFAULT, 0,WndRect.right-WndRect.left, WndRect.bottom-WndRect.top,hWndParent, NULL, g_hInstance, NULL);

	return hWnd;
}

bool LoadX_GetMesh(LPCTSTR lpFile,std::vector<MESHVERTEX> &vertexArray,std::vector<DWORD> &indexArray,std::vector<D3DXATTRIBUTERANGE> &attributes,std::vector<MESHMATERIALINFO> &materialArray)
{
	//EBhE쐬
	HWND hWnd=CreateEmptyWindow(MQ_GetWindowHandle());
	while(UtilDoMessageLoop())continue;
	if(!hWnd)return false;

	//DirectXfoCX쐬
	CDXDevice Device;
	if(!Device.Create(hWnd,SCREEN_WIDTH,SCREEN_HEIGHT)){
		DestroyWindow(hWnd);
		while(UtilDoMessageLoop())continue;
		MessageBox(MQ_GetWindowHandle(),"Failed to create DirectX device",NULL,MB_OK|MB_ICONERROR);
		return false;
	}
	while(UtilDoMessageLoop())continue;
	while(!Device.ResetDeviceIfLost())continue;

	//[h
	CDXMesh mesh;
	if(mesh.Load(Device,lpFile)){
		mesh.GetMeshInfo(vertexArray,indexArray,attributes);
		mesh.GetMaterialArray(materialArray);
	}
	//bVj

	//foCXj
	Device.Destroy();
	//EBhEj
	DestroyWindow(hWnd);
	while(UtilDoMessageLoop())continue;

	return true;
}

#define MSGBOX(x) MessageBox(MQ_GetWindowHandle(),x,NULL,MB_OK)

float getColorRelation(const D3DCOLORVALUE &a,const D3DCOLORVALUE &b)
{
	//FxNg̓(Kς)
	float lenA=sqrt(a.r*a.r + a.g*a.g + a.b*a.b);
	float lenB=sqrt(b.r*b.r + b.g*b.g + b.b*b.b);
	float prod=a.r*b.r + a.g*b.g + a.b*b.b;

	if(lenA<0.0001f || lenB<0.0001f)return 0.0f;
	return prod/(lenA*lenB);
}

BOOL LoadX(LPCTSTR filename, MQDocument doc)
{
	std::vector<MESHVERTEX> vertexArray;
	std::vector<DWORD> indexArray;
	std::vector<D3DXATTRIBUTERANGE> attributes;
	std::vector<MESHMATERIALINFO> materialArray;

	if(!LoadX_GetMesh(filename,vertexArray,indexArray,attributes,materialArray)){
		MSGBOX("Failed to load mesh");
		return FALSE;
	}
	if(vertexArray.empty())return FALSE;

	MQObject lpObj=MQ_CreateObject();
	if(!lpObj)return FALSE;

	//_ɒǉ
	std::vector<int> vertexIndexArray;
	vertexIndexArray.resize(vertexArray.size());
	const float fScale=100.0f;
	for(unsigned int idx=0;idx<vertexArray.size();idx++){
		//NOTE:g嗦100{Ɖ
		vertexIndexArray[idx]=lpObj->AddVertex(MQPoint(
			vertexArray[idx].vPos.x*fScale,
			vertexArray[idx].vPos.y*fScale,
			vertexArray[idx].vPos.z*fScale
			));
		//_F
		//lpObj->SetVertexColor(vertexIndexArray[idx],vertexArray[idx].diffuse | 0xFF000000);
	}

	UINT size=attributes.size();
	for(UINT attIdx=0;attIdx<size;attIdx++){
		MQMaterial mqMaterial=MQ_CreateMaterial();
		//}eA
		char buf[256];
		sprintf_s(buf,"import_x_material%02d",attIdx);
		mqMaterial->SetName(buf);

		const MESHMATERIALINFO &rMat=materialArray[attIdx];
		//F
		mqMaterial->SetColor(MQColor(
			rMat.material.Diffuse.r,
			rMat.material.Diffuse.g,
			rMat.material.Diffuse.b));
		//̑̏
		mqMaterial->SetAmbient(getColorRelation(rMat.material.Diffuse,rMat.material.Ambient));
		//mqMaterial->SetDiffuse(getColorRelation(rMat.material.Diffuse,rMat.material.Diffuse));
		mqMaterial->SetEmission(getColorRelation(rMat.material.Diffuse,rMat.material.Emissive));
		mqMaterial->SetSpecular(getColorRelation(rMat.material.Diffuse,rMat.material.Specular));
		//x
		mqMaterial->SetAlpha(1.0f-rMat.material.Diffuse.a/255.0f);
		//power
		mqMaterial->SetPower(rMat.material.Power);
		//eNX`
		mqMaterial->SetTextureName(rMat.strTextureName.c_str());
		//o^
		int matIdx=doc->AddMaterial(mqMaterial);

		//---
		for(unsigned int faceIdx=attributes[attIdx].FaceStart;faceIdx<attributes[attIdx].FaceStart+attributes[attIdx].FaceCount;faceIdx++){
			//_
			int vertices[]={	//NOTE:DirectXMetasequoiał͋t
				vertexIndexArray[indexArray[faceIdx*3+2]],
				vertexIndexArray[indexArray[faceIdx*3+1]],
				vertexIndexArray[indexArray[faceIdx*3+0]],
			};

			//ʒǉ
			int mqfaceIdx=lpObj->AddFace(3,vertices);
			lpObj->SetFaceMaterial(mqfaceIdx,matIdx);

			//UVW
			MQCoordinate coordinates[]={
				MQCoordinate(vertexArray[indexArray[faceIdx*3+2]].tu,vertexArray[indexArray[faceIdx*3+2]].tv),
				MQCoordinate(vertexArray[indexArray[faceIdx*3+1]].tu,vertexArray[indexArray[faceIdx*3+1]].tv),
				MQCoordinate(vertexArray[indexArray[faceIdx*3+0]].tu,vertexArray[indexArray[faceIdx*3+0]].tv),
			};
			lpObj->SetFaceCoordinateArray(mqfaceIdx,coordinates);
		}
	}

	// ʂ܂o^ĂȂȂFALSEԂ
	if(lpObj->GetFaceCount() == 0){
		lpObj->DeleteThis();
		return FALSE;
	}

	doc->AddObject(lpObj);
	return TRUE;
}
